## spades 3.7.0+dfsg

=== src/corrector/CMakeLists.txt ===
############################################################################
# Copyright (c) 2015 Saint Petersburg State University
# Copyright (c) 2011-2014 Saint Petersburg Academic University
# All Rights Reserved
# See file LICENSE for details.
############################################################################

project(corrector CXX)

include_directories(${CMAKE_CURRENT_SOURCE_DIR})


add_executable(corrector
	    positional_read.cpp
        interesting_pos_processor.cpp
        contig_processor.cpp
        dataset_processor.cpp
        config_struct.cpp
        main.cpp)

target_link_libraries(corrector input yaml-cpp ${COMMON_LIBRARIES})



if (SPADES_STATIC_BUILD)
  set_target_properties(corrector PROPERTIES LINK_SEARCH_END_STATIC 1)
endif()

install(TARGETS corrector
        DESTINATION bin
        COMPONENT runtime)
install(DIRECTORY "${SPADES_CFG_DIR}/corrector"
        DESTINATION share/spades/configs
        FILES_MATCHING PATTERN "*.info.template")

=== src/dipspades/CMakeLists.txt ===
############################################################################
# Copyright (c) 2015 Saint Petersburg State University
# Copyright (c) 2011-2014 Saint Petersburg Academic University
# All Rights Reserved
# See file LICENSE for details.
############################################################################

project(dipspades CXX)

add_executable(dipspades
	       dipspades_config.cpp
	       utils/files_utils.cpp
               main.cpp)

target_include_directories(dipspades PRIVATE ${CMAKE_SOURCE_DIR}/debruijn)
target_link_libraries(dipspades debruijn)

if (SPADES_STATIC_BUILD)
  set_target_properties(dipspades PROPERTIES LINK_SEARCH_END_STATIC 1)
endif()

install(TARGETS dipspades
        DESTINATION bin
        COMPONENT runtime)
install(DIRECTORY "${SPADES_CFG_DIR}/dipspades"
        DESTINATION share/spades/configs
        FILES_MATCHING PATTERN "*.info.template")

=== src/hammer/CMakeLists.txt ===
############################################################################
# Copyright (c) 2015 Saint Petersburg State University
# Copyright (c) 2011-2014 Saint Petersburg Academic University
# All Rights Reserved
# See file LICENSE for details.
############################################################################

project(hammer CXX)

include_directories(${CMAKE_CURRENT_SOURCE_DIR})

add_executable(hammer
               main.cpp
               hammer_tools.cpp
               hamcluster.cpp
               kmer_cluster.cpp
               kmer_data.cpp
               config_struct_hammer.cpp
               read_corrector.cpp
               expander.cpp)

#  add_subdirectory(quake_count)
#  add_subdirectory(gen_test_data)

target_link_libraries(hammer input cityhash BamTools yaml-cpp format input ${COMMON_LIBRARIES})

if (SPADES_STATIC_BUILD)
  set_target_properties(hammer PROPERTIES LINK_SEARCH_END_STATIC 1)
endif()

install(TARGETS hammer
        DESTINATION bin
        COMPONENT runtime)
install(DIRECTORY "${SPADES_CFG_DIR}/hammer"
        DESTINATION share/spades/configs
        FILES_MATCHING PATTERN "*.info.template")

=== src/io/CMakeLists.txt ===
############################################################################
# Copyright (c) 2015 Saint Petersburg State University
# Copyright (c) 2011-2014 Saint Petersburg Academic University
# All Rights Reserved
# See file LICENSE for details.
############################################################################

project(input CXX)

add_library(input STATIC
            parser.cpp
            path_helper.cpp
            copy_file.cpp
            library.cpp
            logger_impl.cpp
            sam/read.cpp
            sam/sam_reader.cpp)

target_link_libraries(input BamTools samtools yaml-cpp)

=== src/scaffold_correction/CMakeLists.txt ===
############################################################################
# Copyright (c) 2015 Saint Petersburg State University
# All Rights Reserved
# See file LICENSE for details.
############################################################################

project(moleculo CXX)


add_executable(scaffold_correction
               main.cpp)
target_include_directories(scaffold_correction PRIVATE ${CMAKE_SOURCE_DIR}/debruijn)
target_link_libraries(scaffold_correction debruijn)

if (SPADES_STATIC_BUILD)
  set_target_properties(scaffold_correction PROPERTIES LINK_SEARCH_END_STATIC 1)
endif()

install(TARGETS scaffold_correction
        DESTINATION bin
        COMPONENT runtime)
install(DIRECTORY "${SPADES_CFG_DIR}/scaffold_correction"
        DESTINATION share/spades/configs
        FILES_MATCHING PATTERN "*.info.template")

=== ext/src/yaml-cpp/CMakeLists.txt ===
project(yaml-cpp)

include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${EXT_DIR}/include)

set(YAML_CPP_VERSION_MAJOR "0")
set(YAML_CPP_VERSION_MINOR "5")
set(YAML_CPP_VERSION_PATCH "0")
set(YAML_CPP_VERSION "${YAML_CPP_VERSION_MAJOR}.${YAML_CPP_VERSION_MINOR}.${YAML_CPP_VERSION_PATCH}")

file(GLOB sources "[a-zA-Z]*.cpp")

add_library(yaml-cpp STATIC
            ${sources})

=== debian/changelog ===
spades (3.7.0+dfsg-1~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- Afif Elghraoui <afif@debian.org>  Sat, 05 Mar 2016 21:08:30 -0800

spades (3.7.0+dfsg-1) unstable; urgency=medium

  * Make changelog building reproducible.
  * New upstream release.
  * Update d/copyright.

 -- Sascha Steinbiss <sascha@steinbiss.name>  Wed, 24 Feb 2016 22:02:53 +0000

spades (3.6.2+dfsg-2) unstable; urgency=medium

  * Use Debian's jemalloc.
  * Fix spelling issues.
  * Bump Standards-Version.

 -- Sascha Steinbiss <sascha@steinbiss.name>  Mon, 22 Feb 2016 09:27:51 +0000

spades (3.6.2+dfsg-1) unstable; urgency=low

  * Initial release (Closes: #813988)

 -- Sascha Steinbiss <sascha@steinbiss.name>  Sun, 07 Feb 2016 10:21:39 +0000

=== debian/control ===
Source: spades
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders:
	Andreas Tille <tille@debian.org>,
	Afif Elghraoui <afif@ghraoui.name>,
	Sascha Steinbiss <sascha@steinbiss.name>
Section: science
Priority: optional
Build-Depends: debhelper (>= 9),
               cmake,
               python-all-dev,
               zlib1g-dev,
               libbz2-dev,
               libboost-dev,
               libbam-dev,
               libbamtools-dev,
               libjemalloc-dev,
               libhts-dev,
               python-yaml,
               python-joblib,
               ruby-ronn,
               bwa,
               lynx
Standards-Version: 3.9.7
Testsuite: autopkgtest
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/spades.git
Vcs-Git: https://anonscm.debian.org/git/debian-med/spades.git
Homepage: http://bioinf.spbau.ru/en/spades

Package: spades
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         python,
         python-joblib,
         python-yaml,
         bwa,
         bamtools,
         samtools,
         libjemalloc1
Description: genome assembler for single-cell and isolates data sets
 The SPAdes – St. Petersburg genome assembler is intended for both
 standard isolates and single-cell MDA bacteria assemblies.  It works
 with Illumina or IonTorrent reads and is capable of providing hybrid
 assemblies using PacBio and Sanger reads. You can also provide
 additional contigs that will be used as long reads.

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1

CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS) $(CPPFLAGS)
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS) $(CPPFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)
DEBPKGNAME := $(shell dpkg-parsechangelog | awk '/^Source:/ {print $$2}')
TMPDIR     := $(CURDIR)/install_spades
LIBDIR     := debian/$(DEBPKGNAME)/usr/lib/spades
mandir     := $(CURDIR)/debian/man
debfolder  := $(CURDIR)/debian

PREFIX:=/usr
BUILD_DIR:=$(CURDIR)/build_spades

DEB_CMAKE_EXTRA_FLAGS = -DSPADES_BOOST_ROOT=/usr/include

%:
	dh $@  --with python2 --sourcedirectory=src --buildsystem=cmake

override_dh_clean:
	dh_clean -X.orig

override_dh_auto_clean:
	dh_auto_clean
	rm -rf build_spades
	rm -rf install_spades
	rm -rf spades_test
	find . -name "*.pyc" -delete
	rm -rf $(debfolder)/man_src/*.html $(debfolder)/man_src/*.?
	rm -rf $(mandir)

override_dh_auto_configure:
	echo "Simply use spades_compile.sh in auto_build"

override_dh_auto_build:
	PREFIX=$(TMPDIR) ./spades_compile.sh

override_dh_installman:
	mkdir -p $(mandir)
	ronn $(debfolder)/man_src/*.ronn
	cp $(debfolder)/man_src/*.? $(mandir)
	dh_installman --

override_dh_auto_test:
	$(TMPDIR)/bin/spades.py --test
	$(TMPDIR)/bin/dipspades.py --test
	# Difficult to test truSPAdes before installing because bwa-spades
	# is still not in the right place. Let's do this later in an
	# autopkgtest.
	# $(TMPDIR)/bin/truspades.py --test

override_dh_auto_install:
	echo "Nothing to install"

override_dh_install:
	dh_install
	mkdir -p $(LIBDIR)
	mv debian/$(DEBPKGNAME)/usr/bin $(LIBDIR)
	mkdir -p debian/$(DEBPKGNAME)/usr/bin
	install debian/bin/spades debian/$(DEBPKGNAME)/usr/bin/
	chmod +x debian/$(DEBPKGNAME)/usr/bin/spades
	rm -f debian/$(DEBPKGNAME)/usr/share/spades/GPLv2.txt
	rm -f debian/$(DEBPKGNAME)/usr/share/spades/LICENSE

override_dh_installdocs:
	dh_installdocs

override_dh_installchangelogs:
	LC_ALL=C.UTF-8 lynx -dump changelog.html > changelog
	dh_installchangelogs changelog
	rm changelog

## spades 3.7.1+dfsg

=== src/CMakeLists.txt ===
# -*- cmake -*-
############################################################################
# Copyright (c) 2015 Saint Petersburg State University
# Copyright (c) 2011-2014 Saint Petersburg Academic University
# All Rights Reserved
# See file LICENSE for details.
############################################################################

# Hard prerequisites
cmake_minimum_required(VERSION 2.8.12)

# allow more human readable "if then else" constructs
set(CMAKE_ALLOW_LOOSE_LOOP_CONSTRUCTS TRUE) 

# modules to find additional libraries (like zlib, boost and etc)
# Add path for custom modules
set(CMAKE_MODULE_PATH
  ${CMAKE_MODULE_PATH}
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake"
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules")
# Define various dirs
set(SPADES_MAIN_SRC_DIR ${CMAKE_CURRENT_SOURCE_DIR})
set(SPADES_MAIN_INCLUDE_DIR ${SPADES_MAIN_SRC_DIR}/include)
set(SPADES_BINARY_DIR ${CMAKE_CURRENT_BINARY_DIR})
set(SPADES_TOOLS_BINARY_DIR ${SPADES_BINARY_DIR}/bin)
set(SPADES_BUILT_INCLUDE_DIR ${SPADES_BINARY_DIR}/include)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${SPADES_TOOLS_BINARY_DIR})
set(EXT_DIR "${CMAKE_SOURCE_DIR}/../ext")
set(SPADES_CFG_DIR "${CMAKE_SOURCE_DIR}/../configs")

# Everything option-dependent
include(options)

# Sanity check our source directory to make sure that we are not trying to
# generate an in-tree build 
if ((CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR) OR
    (CMAKE_SOURCE_DIR STREQUAL "${CMAKE_BINARY_DIR}/src"))
  message(FATAL_ERROR "In-source builds are not allowed.
Please create a directory and run cmake from there, passing the path
to this source directory as the last argument.
This process created the file `CMakeCache.txt' and the directory `CMakeFiles'.
Please delete them.")
endif()

# Handle commond deps
include(deps)

# Add flags if necessary
include(flags)

# Handle common includes
include(includes)

# Handle common libs
include(libs)

include(GetGitRevisionDescription)
get_git_head_revision(SPADES_GIT_REFSPEC SPADES_GIT_SHA1)
if ((NOT SPADES_GIT_REFSPEC) OR (SPADES_GIT_REFSPEC STREQUAL "GITDIR-NOTFOUND"))
  set(SPADES_GIT_REFSPEC "N/A")
endif()
if (NOT SPADES_GIT_SHA1)
  set(SPADES_GIT_SHA1 "N/A")
endif()

message("Building SPAdes from ${SPADES_GIT_REFSPEC}, sha: ${SPADES_GIT_SHA1}")

configure_file("${SPADES_MAIN_INCLUDE_DIR}/config.hpp.in"
               "${SPADES_BUILT_INCLUDE_DIR}/config.hpp")
configure_file("${SPADES_MAIN_INCLUDE_DIR}/version.hpp.in"
               "${SPADES_BUILT_INCLUDE_DIR}/version.hpp")

# Build external dependencies (if any)
add_subdirectory("${EXT_DIR}/src" "${Project_BINARY_DIR}/ext")
add_subdirectory("${EXT_DIR}/tools" "${Project_BINARY_DIR}/ext_tools")

# Setup warnings
add_compile_options(-Wall -Wextra -Wconversion -Wno-sign-conversion -Wno-long-long -Wwrite-strings)
if (NOT OPENMP_FOUND)
  add_compile_options(-Wno-unknown-pragmas)
endif()

# sub projects
add_subdirectory(io)
add_subdirectory(debruijn)
add_subdirectory(hammer)
add_subdirectory(ionhammer)
add_subdirectory(spades_pipeline)
add_subdirectory(dipspades)
add_subdirectory(corrector)
add_subdirectory(scaffold_correction)

# Main pipeline script
install(PROGRAMS "${CMAKE_CURRENT_SOURCE_DIR}/../spades.py"
        DESTINATION bin
        COMPONENT runtime)
install(PROGRAMS "${CMAKE_CURRENT_SOURCE_DIR}/../truspades.py"
        DESTINATION bin
        COMPONENT runtime)
install(PROGRAMS "${CMAKE_CURRENT_SOURCE_DIR}/../dipspades.py"
        DESTINATION bin
        COMPONENT runtime)
install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/../spades_init.py"
        DESTINATION bin
        COMPONENT runtime)
# FIXME: Should we just configure spades_init instead?
install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/../VERSION"
        DESTINATION share/spades
        COMPONENT runtime)
# Test datasets
install(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/../test_dataset"
        DESTINATION share/spades)
install(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/../test_dataset_truspades"
        DESTINATION share/spades)
# manual, LICENSE, and GPLv2
install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/../manual.html"
        DESTINATION share/spades
        COMPONENT runtime)
install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/../dipspades_manual.html"
        DESTINATION share/spades
        COMPONENT runtime)
install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/../truspades_manual.html"
        DESTINATION share/spades
        COMPONENT runtime)
install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/../LICENSE"
        DESTINATION share/spades
        COMPONENT runtime)
install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/../GPLv2.txt"
        DESTINATION share/spades
        COMPONENT runtime)

# Random stuff
include(CMakeListsInternal.txt)

# Packaging
include(pack)

# Workaround for poor CLion users
file(GLOB_RECURSE clion_all_headers
  ${CMAKE_SOURCE_DIR}/*.hpp ${CMAKE_SOURCE_DIR}/*.h)
add_custom_target(all_clion SOURCES ${clion_all_headers})

=== ext/src/CMakeLists.txt ===
# -*- cmake -*-

add_subdirectory(jemalloc)
add_subdirectory(nlopt)
add_subdirectory(python_libs/joblib2)
add_subdirectory(python_libs/joblib3)
add_subdirectory(python_libs/pyyaml2)
add_subdirectory(python_libs/pyyaml3)
add_subdirectory(yaml-cpp)
add_subdirectory(ConsensusCore)
add_subdirectory(bamtools)
add_subdirectory(samtools)
add_subdirectory(cppformat)
add_subdirectory(ssw)
add_subdirectory(cityhash)

=== src/debruijn/CMakeLists.txt ===
############################################################################
# Copyright (c) 2015 Saint Petersburg State University
# Copyright (c) 2011-2014 Saint Petersburg Academic University
# All Rights Reserved
# See file LICENSE for details.
############################################################################

project(spades CXX)

add_library(debruijn STATIC
            kmer_coverage_model.cpp
            config_struct.cpp
            path_extend/pe_config_struct.cpp
            path_extend/bidirectional_path.cpp
            path_extend/scaffolder2015/scaff_supplementary.cpp
            path_extend/scaffolder2015/extension_chooser2015.cpp
            path_extend/scaffolder2015/scaffold_graph.cpp
            path_extend/scaffolder2015/scaffold_graph_constructor.cpp
            path_extend/scaffolder2015/scaffold_graph_visualizer.cpp
            path_extend/scaffolder2015/connection_condition2015.cpp
            genome_consistance_checker.cpp
            stage.cpp
            construction.cpp
            gap_closer.cpp
            simplification.cpp
            mismatch_correction.cpp
            pair_info_count.cpp
            second_phase_setup.cpp
            distance_estimation.cpp
            repeat_resolving.cpp
            genomic_info_filler.cpp
            pacbio_aligning.cpp
            bwa_pair_info_filler.cpp
            genome_storage.cpp)
  
target_include_directories(debruijn PRIVATE ${EXT_DIR}/include/ConsensusCore)
target_link_libraries(debruijn ConsensusCore input cityhash nlopt BamTools ssw yaml-cpp ${COMMON_LIBRARIES})

add_executable(spades
               main.cpp)
target_link_libraries(spades debruijn)


if (SPADES_STATIC_BUILD)
  set_target_properties(spades PROPERTIES LINK_SEARCH_END_STATIC 1)
endif()

install(TARGETS spades
        DESTINATION bin
        COMPONENT runtime)
install(DIRECTORY "${SPADES_CFG_DIR}/debruijn"
        DESTINATION share/spades/configs
        FILES_MATCHING PATTERN "*.info.template")

=== src/ionhammer/CMakeLists.txt ===
############################################################################
# Copyright (c) 2015 Saint Petersburg State University
# Copyright (c) 2011-2014 Saint-Petersburg Academic University
# All Rights Reserved
# See file LICENSE for details.
############################################################################

project(ionhammer CXX)

include_directories(${CMAKE_CURRENT_SOURCE_DIR})

add_executable(ionhammer
               kmer_data.cpp
               hamcluster.cpp
               subcluster.cpp
               err_helper_table.cpp
               config_struct.cpp
               expander.cpp
               seqeval/BaseHypothesisEvaluator.cpp
               seqeval/TreephaserLite.cpp
               main.cpp)

target_link_libraries(ionhammer input cityhash BamTools yaml-cpp input ${COMMON_LIBRARIES})

if (SPADES_STATIC_BUILD)
  set_target_properties(ionhammer PROPERTIES LINK_SEARCH_END_STATIC 1)
endif()

install(TARGETS ionhammer
        RUNTIME DESTINATION bin)
install(DIRECTORY "${SPADES_CFG_DIR}/ionhammer"
        DESTINATION share/spades/configs
                FILES_MATCHING PATTERN "*.cfg.template")

=== debian/changelog ===
spades (3.7.1+dfsg-3) unstable; urgency=medium

  * Force LANG and LANGUAGE to ensure reproducibility.
  * Enable compiler messages.

 -- Sascha Steinbiss <sascha@steinbiss.name>  Thu, 21 Apr 2016 14:44:14 +0000

spades (3.7.1+dfsg-2) unstable; urgency=medium

  [ Sascha Steinbiss ]
  * Use asciidoctor instead of ronn for reproducible man pages
  * enable full hardening
  * add override for pedantic Lintian msg
  * use correct YAML module
    Closes: #818584

  [ Afif Elghraoui ]
  * Replace patch with a sed command to fix python-yaml imports

 -- Sascha Steinbiss <sascha@steinbiss.name>  Fri, 18 Mar 2016 14:25:06 +0000

spades (3.7.1+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Add gbp.conf to always use pristine-tar.

 -- Sascha Steinbiss <sascha@steinbiss.name>  Sat, 12 Mar 2016 07:23:31 +0000

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders:
 	Andreas Tille <tille@debian.org>,
-	Afif Elghraoui <afif@ghraoui.name>,
+	Afif Elghraoui <afif@debian.org>,
 	Sascha Steinbiss <sascha@steinbiss.name>
 Section: science
 Priority: optional
@@ -18,7 +18,7 @@
                libhts-dev,
                python-yaml,
                python-joblib,
-               ruby-ronn,
+               asciidoctor (>= 1.5.3),
                bwa,
                lynx
 Standards-Version: 3.9.7

=== debian/rules ===
--- 
+++ 
@@ -16,6 +16,7 @@
 BUILD_DIR:=$(CURDIR)/build_spades
 
 DEB_CMAKE_EXTRA_FLAGS = -DSPADES_BOOST_ROOT=/usr/include
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 %:
 	dh $@  --with python2 --sourcedirectory=src --buildsystem=cmake
@@ -37,10 +38,15 @@
 
 override_dh_auto_build:
 	PREFIX=$(TMPDIR) ./spades_compile.sh
+# Use Debian-packaged yaml module
+	find $(TMPDIR) \
+	-type f \
+	-print0 \
+	-exec sed -i 's/pyyaml[2|3]/yaml/' {} +
 
 override_dh_installman:
 	mkdir -p $(mandir)
-	ronn $(debfolder)/man_src/*.ronn
+	asciidoctor -a docdate='' -b manpage $(debfolder)/man_src/*.adoc
 	cp $(debfolder)/man_src/*.? $(mandir)
 	dh_installman --
 
@@ -69,6 +75,6 @@
 	dh_installdocs
 
 override_dh_installchangelogs:
-	LC_ALL=C.UTF-8 lynx -dump changelog.html > changelog
+	LANG="C" LANGUAGE="en_US:en" LC_ALL=C.UTF-8 lynx -dump changelog.html > changelog
 	dh_installchangelogs changelog
 	rm changelog

## spades 3.8.0+dfsg

=== debian/changelog ===
spades (3.8.0+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Drop patches that are no longer necessary.
  * Update licenses.
  * Add metaspades and plasmidspades symlinks.
  * Add man page stubs for metaspades and plasmidspades.
  * Bump Standards-Version.

 -- Sascha Steinbiss <sascha@steinbiss.name>  Sun, 05 Jun 2016 09:56:42 +0000

=== debian/rules ===
--- 
+++ 
@@ -17,6 +17,7 @@
 
 DEB_CMAKE_EXTRA_FLAGS = -DSPADES_BOOST_ROOT=/usr/include
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+export LC_ALL = C
 
 %:
 	dh $@  --with python2 --sourcedirectory=src --buildsystem=cmake
@@ -53,6 +54,7 @@
 override_dh_auto_test:
 	$(TMPDIR)/bin/spades.py --test
 	$(TMPDIR)/bin/dipspades.py --test
+	$(TMPDIR)/bin/metaspades.py --test
 	# Difficult to test truSPAdes before installing because bwa-spades
 	# is still not in the right place. Let's do this later in an
 	# autopkgtest.

## spades 3.8.1+dfsg

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -20,6 +20,7 @@
   "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules")
 # Define various dirs
 set(SPADES_MAIN_SRC_DIR ${CMAKE_CURRENT_SOURCE_DIR})
+set(SPADES_MODULES_DIR ${SPADES_MAIN_SRC_DIR}/modules)
 set(SPADES_MAIN_INCLUDE_DIR ${SPADES_MAIN_SRC_DIR}/include)
 set(SPADES_BINARY_DIR ${CMAKE_CURRENT_BINARY_DIR})
 set(SPADES_TOOLS_BINARY_DIR ${SPADES_BINARY_DIR}/bin)
@@ -81,25 +82,31 @@
 endif()
 
 # sub projects
-add_subdirectory(io)
-add_subdirectory(debruijn)
-add_subdirectory(hammer)
-add_subdirectory(ionhammer)
+add_subdirectory(modules)
+add_subdirectory(projects)
 add_subdirectory(spades_pipeline)
-add_subdirectory(dipspades)
-add_subdirectory(corrector)
-add_subdirectory(scaffold_correction)
+
 
 # Main pipeline script
 install(PROGRAMS "${CMAKE_CURRENT_SOURCE_DIR}/../spades.py"
         DESTINATION bin
         COMPONENT runtime)
+install(PROGRAMS "${CMAKE_CURRENT_SOURCE_DIR}/../dipspades.py"
+        DESTINATION bin
+        COMPONENT runtime)
+install(PROGRAMS "${CMAKE_CURRENT_SOURCE_DIR}/../metaspades.py"
+        DESTINATION bin
+        COMPONENT runtime)
+install(PROGRAMS "${CMAKE_CURRENT_SOURCE_DIR}/../plasmidspades.py"
+        DESTINATION bin
+        COMPONENT runtime)
+#install(PROGRAMS "${CMAKE_CURRENT_SOURCE_DIR}/../rnaspades.py"
+#        DESTINATION bin
+#        COMPONENT runtime)
 install(PROGRAMS "${CMAKE_CURRENT_SOURCE_DIR}/../truspades.py"
         DESTINATION bin
         COMPONENT runtime)
-install(PROGRAMS "${CMAKE_CURRENT_SOURCE_DIR}/../dipspades.py"
-        DESTINATION bin
-        COMPONENT runtime)
+
 install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/../spades_init.py"
         DESTINATION bin
         COMPONENT runtime)

=== src/projects/CMakeLists.txt ===
############################################################################
# Copyright (c) 2015 Saint Petersburg State University
# Copyright (c) 2011-2014 Saint Petersburg Academic University
# All Rights Reserved
# See file LICENSE for details.
############################################################################

add_subdirectory(spades)
add_subdirectory(hammer)
add_subdirectory(ionhammer)
add_subdirectory(dipspades)
add_subdirectory(corrector)
add_subdirectory(scaffold_correction)

=== ext/src/htrie/CMakeLists.txt ===
############################################################################
# Copyright (c) 2015 Saint Petersburg State University
# All Rights Reserved
# See file LICENSE for details.
############################################################################

project(hattrie C)

add_library(hattrie STATIC
            ahtable.c hat-trie.c misc.c murmurhash3.c)

=== ext/src/ssw/CMakeLists.txt ===
############################################################################
# Copyright (c) 2015 Saint Petersburg State University
# All Rights Reserved
# See file LICENSE for details.
############################################################################

project(ssw C CXX)

add_library(ssw STATIC
            ssw.c
            ssw_cpp.cpp)

=== src/modules/assembly_graph/CMakeLists.txt ===
############################################################################
# Copyright (c) 2015 Saint Petersburg State University
# Copyright (c) 2011-2014 Saint Petersburg Academic University
# All Rights Reserved
# See file LICENSE for details.
############################################################################

project(graph_support CXX)

add_library(graph_support STATIC
            components/connected_component.cpp paths/bidirectional_path.cpp graph_support/scaff_supplementary.cpp)
target_link_libraries(graph_support hattrie)

=== src/modules/algorithms/path_extend/utils/CMakeLists.txt ===
############################################################################
# Copyright (c) 2015 Saint Petersburg State University
# Copyright (c) 2011-2014 Saint Petersburg Academic University
# All Rights Reserved
# See file LICENSE for details.
############################################################################

project(utils CXX)

add_executable(utils
 paired_info_checker.cpp)

target_link_libraries(utils ${COMMON_LIBRARIES} input)

=== debian/changelog ===
spades (3.8.1+dfsg-1~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- Sascha Steinbiss <sascha@steinbiss.name>  Mon, 13 Jun 2016 09:52:56 +0000

spades (3.8.1+dfsg-1) unstable; urgency=medium

  * New upstream release.

 -- Sascha Steinbiss <sascha@steinbiss.name>  Mon, 13 Jun 2016 09:02:52 +0000

spades (3.7.1+dfsg-2~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.
  * Revert switch to asciidoctor for building manpages.

 -- Afif Elghraoui <afif@debian.org>  Fri, 25 Mar 2016 21:59:57 -0700

=== debian/control ===
--- 
+++ 
@@ -18,10 +18,10 @@
                libhts-dev,
                python-yaml,
                python-joblib,
-               asciidoctor (>= 1.5.3),
+               ruby-ronn,
                bwa,
                lynx
-Standards-Version: 3.9.7
+Standards-Version: 3.9.8
 Testsuite: autopkgtest
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/spades.git
 Vcs-Git: https://anonscm.debian.org/git/debian-med/spades.git

=== debian/rules ===
--- 
+++ 
@@ -47,7 +47,7 @@
 
 override_dh_installman:
 	mkdir -p $(mandir)
-	asciidoctor -a docdate='' -b manpage $(debfolder)/man_src/*.adoc
+	ronn $(debfolder)/man_src/*.ronn
 	cp $(debfolder)/man_src/*.? $(mandir)
 	dh_installman --

## spades 3.8.2+dfsg

=== debian/changelog ===
spades (3.8.2+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Adapt patches for new upstream code.
  * Remove unused override.
  * Build with debug symbols.

 -- Sascha Steinbiss <satta@debian.org>  Mon, 11 Jul 2016 08:39:53 +0000

spades (3.8.1+dfsg-2) unstable; urgency=medium

  * Stop using embedded libnlopt, libssw and libhat-trie.
  * Update email addresses.

 -- Sascha Steinbiss <satta@debian.org>  Sat, 02 Jul 2016 17:45:37 +0000

## spades 3.8.2+dfsg2

=== debian/changelog ===
spades (3.8.2+dfsg2-1) unstable; urgency=medium

  * Make sure bundled headers are not used by cleaning orig tarball.

 -- Sascha Steinbiss <satta@debian.org>  Tue, 19 Jul 2016 20:57:51 +0000

## spades 3.9.0+dfsg

=== src/modules/assembly_graph/CMakeLists.txt ===
--- 
+++ 
@@ -8,5 +8,5 @@
 project(graph_support CXX)
 
 add_library(graph_support STATIC
-            components/connected_component.cpp paths/bidirectional_path.cpp graph_support/scaff_supplementary.cpp)
+            components/connected_component.cpp paths/bidirectional_path.cpp graph_support/scaff_supplementary.cpp graph_alignment/edge_index_refiller.cpp)
 target_link_libraries(graph_support hattrie)

=== src/projects/dipspades/CMakeLists.txt ===
############################################################################
# Copyright (c) 2015 Saint Petersburg State University
# Copyright (c) 2011-2014 Saint Petersburg Academic University
# All Rights Reserved
# See file LICENSE for details.
############################################################################

project(dipspades CXX)

add_executable(dipspades
	       dipspades_config.cpp
	       utils/files_utils.cpp
               main.cpp)

target_link_libraries(dipspades spades_modules ${COMMON_LIBRARIES})

if (SPADES_STATIC_BUILD)
  set_target_properties(dipspades PROPERTIES LINK_SEARCH_END_STATIC 1)
endif()

install(TARGETS dipspades
        DESTINATION bin
        COMPONENT runtime)
install(DIRECTORY "${SPADES_CFG_DIR}/dipspades"
        DESTINATION share/spades/configs
        FILES_MATCHING PATTERN "*.info")

=== src/projects/mph_test/CMakeLists.txt ===
############################################################################
# Copyright (c) 2016 Saint Petersburg State University
# All Rights Reserved
# See file LICENSE for details.
############################################################################

project(spades-kmercount CXX)

include_directories(${CMAKE_CURRENT_SOURCE_DIR})


add_executable(spades-kmercount
               main.cpp)

target_link_libraries(spades-kmercount spades_modules ${COMMON_LIBRARIES})

=== src/projects/scaffold_correction/CMakeLists.txt ===
############################################################################
# Copyright (c) 2015 Saint Petersburg State University
# All Rights Reserved
# See file LICENSE for details.
############################################################################

project(moleculo CXX)


add_executable(scaffold_correction
               main.cpp)
target_link_libraries(scaffold_correction spades_modules ${COMMON_LIBRARIES})

if (SPADES_STATIC_BUILD)
  set_target_properties(scaffold_correction PROPERTIES LINK_SEARCH_END_STATIC 1)
endif()

install(TARGETS scaffold_correction
        DESTINATION bin
        COMPONENT runtime)
install(DIRECTORY "${SPADES_CFG_DIR}/scaffold_correction"
        DESTINATION share/spades/configs
        FILES_MATCHING PATTERN "*.info")

=== ext/src/bamtools/api/internal/utils/CMakeLists.txt ===
# ==========================
# BamTools CMakeLists.txt
# (c) 2011 Derek Barnett
#
# src/api/internal/utils
# ==========================

set( InternalUtilsDir "${InternalDir}/utils" )

set( InternalUtilsSources
        ${InternalUtilsDir}/BamException_p.cpp

        PARENT_SCOPE # <-- leave this last
)

=== debian/changelog ===
spades (3.9.0+dfsg-1~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.
  * Switch manpage building back to asciidoctor.

 -- Afif Elghraoui <afif@debian.org>  Sat, 30 Jul 2016 19:33:47 -0700

spades (3.9.0+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Add copyright entry for cxxopts.
  * Add rnaSPAdes manpage, wrappers, tests.

 -- Sascha Steinbiss <satta@debian.org>  Sun, 24 Jul 2016 13:12:31 +0000

## spades 3.9.1+dfsg

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -100,9 +100,9 @@
 install(PROGRAMS "${CMAKE_CURRENT_SOURCE_DIR}/../plasmidspades.py"
         DESTINATION bin
         COMPONENT runtime)
-#install(PROGRAMS "${CMAKE_CURRENT_SOURCE_DIR}/../rnaspades.py"
-#        DESTINATION bin
-#        COMPONENT runtime)
+install(PROGRAMS "${CMAKE_CURRENT_SOURCE_DIR}/../rnaspades.py"
+        DESTINATION bin
+        COMPONENT runtime)
 install(PROGRAMS "${CMAKE_CURRENT_SOURCE_DIR}/../truspades.py"
         DESTINATION bin
         COMPONENT runtime)
@@ -129,6 +129,9 @@
 install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/../truspades_manual.html"
         DESTINATION share/spades
         COMPONENT runtime)
+install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/../rnaspades_manual.html"
+        DESTINATION share/spades
+        COMPONENT runtime)
 install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/../LICENSE"
         DESTINATION share/spades
         COMPONENT runtime)

=== ext/src/CMakeLists.txt ===
--- 
+++ 
@@ -6,10 +6,11 @@
 add_subdirectory(python_libs/joblib3)
 add_subdirectory(python_libs/pyyaml2)
 add_subdirectory(python_libs/pyyaml3)
-add_subdirectory(yaml-cpp)
 add_subdirectory(ConsensusCore)
 add_subdirectory(bamtools)
 add_subdirectory(samtools)
 add_subdirectory(cppformat)
 add_subdirectory(ssw)
 add_subdirectory(cityhash)
+add_subdirectory(llvm)
+add_subdirectory(htrie)

=== src/modules/CMakeLists.txt ===
############################################################################
# Copyright (c) 2015 Saint Petersburg State University
# Copyright (c) 2011-2014 Saint Petersburg Academic University
# All Rights Reserved
# See file LICENSE for details.
############################################################################

project(spades_modules CXX)

add_subdirectory(pipeline)
add_subdirectory(assembly_graph)
add_subdirectory(data_structures/sequence)
add_subdirectory(math)
add_subdirectory(algorithms/path_extend)
add_subdirectory(algorithms)
add_subdirectory(paired_info)
add_subdirectory(stages)
add_subdirectory(dev_support)
add_subdirectory(io)
add_subdirectory(data_structures/mph_index)

add_library(spades_modules STATIC empty.cpp)

target_link_libraries(spades_modules graph_support input sequence pipeline math_module path_extend paired_info stages dev_support mph_index algorithms)

=== src/projects/CMakeLists.txt ===
--- 
+++ 
@@ -11,3 +11,12 @@
 add_subdirectory(dipspades)
 add_subdirectory(corrector)
 add_subdirectory(scaffold_correction)
+
+if ("${CMAKE_CXX_COMPILER_ID}" MATCHES "GNU")
+  # Require at least gcc 4.8
+  if (NOT CMAKE_CXX_COMPILER_VERSION VERSION_LESS 4.8)
+    add_subdirectory(mph_test)
+  endif()
+else()
+  add_subdirectory(mph_test)
+endif()

=== src/spades_pipeline/CMakeLists.txt ===
############################################################################
# Copyright (c) 2015 Saint Petersburg State University
# Copyright (c) 2011-2014 Saint Petersburg Academic University
# All Rights Reserved
# See file LICENSE for details.
############################################################################

project(spades_pipeline)

# SPAdes pipeline scripts
install(FILES hammer_logic.py process_cfg.py spades_logic.py dipspades_logic.py corrector_logic.py support.py options_storage.py lucigen_nxmate.py
        DESTINATION share/spades/spades_pipeline
        COMPONENT runtime)
# TruSpades module
install(FILES truspades/reference_construction.py truspades/moleculo_filter_contigs.py truspades/break_by_coverage.py truspades/moleculo_postprocessing.py truspades/barcode_extraction.py truspades/generate_quality.py truspades/id_generation.py truspades/launch_options.py truspades/string_dist_utils.py
        DESTINATION share/spades/spades_pipeline/truspades
        COMPONENT runtime)
# Common module
install(FILES common/alignment.py common/parallel_launcher.py common/sam_parser.py common/SeqIO.py
        DESTINATION share/spades/spades_pipeline/common
        COMPONENT runtime)

=== ext/src/ConsensusCore/CMakeLists.txt ===
project(ConsensusCore CXX)

include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${EXT_DIR}/include/ConsensusCore)

add_library(ConsensusCore STATIC 
            AffineAlignment.cpp
            Coverage.cpp
            Feature.cpp
            Features.cpp
            Mutation.cpp
            PairwiseAlignment.cpp
            Sequence.cpp
            Utils.cpp
            Version.cpp
            Matrix/DenseMatrix.cpp
            Matrix/SparseMatrix.cpp
            Poa/PoaConfig.cpp
            Poa/PoaConsensus.cpp
            Poa/PoaGraph.cpp)

=== ext/src/llvm/CMakeLists.txt ===
project(llvm-support)

include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${EXT_DIR}/include)

include(CheckIncludeFiles)
include(CheckIncludeFileCXX)
include(CheckSymbolExists)

check_include_files(execinfo.h  HAVE_EXECINFO_H)
check_include_files(signal.h    HAVE_SIGNAL_H)
check_include_files(sys/stat.h  HAVE_SYS_STAT_H)
check_include_files(cxxabi.h    HAVE_CXXABI_H)
check_include_files(dlfcn.h     HAVE_DLFCN_H)
check_include_files(mach/mach.h HAVE_MACH_MACH_H)
check_include_files(link.h      HAVE_LINK_H)

check_symbol_exists(backtrace "execinfo.h" HAVE_BACKTRACE)

find_library(DL_LIB NAMES "dl")

# FIXME: Signal handler return type, currently hardcoded to 'void'
set(RETSIGTYPE void)

configure_file(${EXT_DIR}/include/llvm/Config.h.in
               ${SPADES_BUILT_INCLUDE_DIR}/llvm/Config.h)

file(GLOB sources "[a-zA-Z]*.cpp" "[a-zA-Z]*.c")

add_library(llvm-support STATIC
  ${sources})
if (DL_LIB)
  target_link_libraries(llvm-support ${DL_LIB})
endif()

=== src/modules/algorithms/CMakeLists.txt ===
############################################################################
# Copyright (c) 2015 Saint Petersburg State University
# Copyright (c) 2011-2014 Saint Petersburg Academic University
# All Rights Reserved
# See file LICENSE for details.
############################################################################

project(algorithms CXX)

add_library(algorithms STATIC genome_consistance_checker.cpp)

=== src/modules/dev_support/CMakeLists.txt ===
############################################################################
# Copyright (c) 2015 Saint Petersburg State University
# Copyright (c) 2011-2014 Saint Petersburg Academic University
# All Rights Reserved
# See file LICENSE for details.
############################################################################

project(dev_support CXX)

add_library(dev_support STATIC
            copy_file.cpp
            path_helper.cpp
            logger/logger_impl.cpp)

=== src/modules/io/CMakeLists.txt ===
############################################################################
# Copyright (c) 2015 Saint Petersburg State University
# Copyright (c) 2011-2014 Saint Petersburg Academic University
# All Rights Reserved
# See file LICENSE for details.
############################################################################

project(input CXX)

add_library(input STATIC
            reads_io/parser.cpp
            sam_io/read.cpp
            sam_io/sam_reader.cpp)

target_link_libraries(input BamTools samtools)

=== src/modules/math/CMakeLists.txt ===
############################################################################
# Copyright (c) 2015 Saint Petersburg State University
# Copyright (c) 2011-2014 Saint Petersburg Academic University
# All Rights Reserved
# See file LICENSE for details.
############################################################################

project(math_module CXX)

add_library(math_module STATIC
            kmer_coverage_model.cpp)

target_link_libraries(math_module nlopt)

=== src/modules/paired_info/CMakeLists.txt ===
############################################################################
# Copyright (c) 2015 Saint Petersburg State University
# Copyright (c) 2011-2014 Saint Petersburg Academic University
# All Rights Reserved
# See file LICENSE for details.
############################################################################

project(paired_info CXX)

add_library(paired_info STATIC
            bwa_pair_info_filler.cpp)

target_link_libraries(paired_info input)

=== debian/changelog ===
spades (3.9.1+dfsg-1) unstable; urgency=medium

  * New upstream release.

 -- Sascha Steinbiss <satta@debian.org>  Wed, 07 Dec 2016 06:31:19 +0000

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Uploaders:
 	Andreas Tille <tille@debian.org>,
 	Afif Elghraoui <afif@debian.org>,
-	Sascha Steinbiss <sascha@steinbiss.name>
+	Sascha Steinbiss <satta@debian.org>
 Section: science
 Priority: optional
 Build-Depends: debhelper (>= 9),
@@ -15,10 +15,13 @@
                libbam-dev,
                libbamtools-dev,
                libjemalloc-dev,
+               libhat-trie-dev,
                libhts-dev,
+               libnlopt-dev,
+               libssw-dev,
                python-yaml,
                python-joblib,
-               ruby-ronn,
+               asciidoctor (>= 1.5.3),
                bwa,
                lynx
 Standards-Version: 3.9.8
@@ -37,7 +40,10 @@
          bwa,
          bamtools,
          samtools,
-         libjemalloc1
+         libjemalloc1,
+         libnlopt0,
+         libhat-trie0,
+         libssw0
 Description: genome assembler for single-cell and isolates data sets
  The SPAdes – St. Petersburg genome assembler is intended for both
  standard isolates and single-cell MDA bacteria assemblies.  It works
